unit ADOUserControl;

interface

uses
  SysUtils, Classes, UCDefine, UCConsts, UCMessages, ADODB, DB,
  Dialogs, Menus, ActnList;

type
  TADOUserControl = class(TUCDefine)
  private
    FConnection : TADOConnection;
    procedure SetADOConnection(Value : TADOConnection);

  protected
    procedure CriaCadUserForm;override;
    procedure CriaProfileUserForm;override;
    procedure ActionLog(Sender : TObject); override;
    procedure ActionBtPermiss(Sender : TObject);override;
    procedure ActionBtPermissProfile(Sender: TObject);override;
    procedure Notification(AComponent: TComponent; Operation: TOperation);override;
    procedure UCExecSQL(FSQL: String);override;
    function UCGetSQLDataset(FSQL : String) : TDataset;override;
    function UCFindTable(const Tablename : String) : Boolean; override;
    function UCFindDataConnection : Boolean; override;
  public
    property CurrentUser;
  published
    property Connection : TADOConnection read FConnection write SetADOConnection;
  end;



procedure Register;

implementation

uses UserPermis_U, CadUser_U, CadPerfil_U, TrocaSenha_U, LoginWindow_U,
  ViewLog_U;

{ TADOUserControl }


procedure TADOUserControl.ActionBtPermiss(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asString + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSCmd := TADOQuery.Create(self);
  TADOQuery(UserPermis.DSCmd).Connection := FConnection;

  UserPermis.DSPerfil := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + IntToStr(TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Perfil').asInteger) + ' and Modulo = '+QuotedStr(ApplicationID));
  UserPermis.DSPerfil.Open;

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TADOUserControl.ActionBtPermissProfile(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asString + ' and Modulo = '+QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSCmd := TADOQuery.Create(self);
  TADOQuery(UserPermis.DSCmd).Connection := FConnection;

  UserPermis.DSPerfil := TDataset.Create(nil);

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TADOUserControl.CriaCadUserForm;
begin
  inherited;
  TCadUser(FormCadastroUsuarios).DSCadUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('U')+' ORDER BY Login');
  TCadUser(FormCadastroUsuarios).DSCadUser.Open;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[0].Title.Caption := Settings.UsersForm.ColName;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[1].Title.Caption := Settings.UsersForm.ColLogin;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[2].Title.Caption := Settings.UsersForm.ColEmail;

  TCadUser(FormCadastroUsuarios).DScmd := TADOQuery.Create(self);
  TADOQuery(TCadUser(FormCadastroUsuarios).DSCMD).Connection := FConnection;

  TCadUser(FormCadastroUsuarios).DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('P')+' ORDER BY Nome');
  TCadUser(FormCadastroUsuarios).DSPerfilUser.Open;
end;

procedure TADOUserControl.CriaProfileUserForm;
begin
  inherited;
  TCadPerfil(FormPerfilUsuarios).DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios +' Where Tipo = '+QuotedStr('P'));
  TCadPerfil(FormPerfilUsuarios).DSPerfilUser.Open;
  TCadPerfil(FormPerfilUsuarios).DBGrid1.Columns[0].Title.Caption := Settings.UsersProfile.ColProfile;

  TCadPerfil(FormPerfilUsuarios).DSCmd := TADOQuery.Create(self);
  TADOQuery(TCadPerfil(FormPerfilUsuarios).DSCmd).Connection := FConnection;

end;

procedure TADOUserControl.SetADOConnection(Value: TADOConnection);
begin
  if FConnection <> Value then FConnection := Value;
  if FConnection <> nil then FConnection.FreeNotification(Self);
end;

procedure Register;
begin
  RegisterComponents('User Control', [TADOUserControl]);
end;


procedure TADOUserControl.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  if (Operation = opRemove) and (AComponent = FConnection) then
  begin
    FConnection := nil;
  end;
  inherited Notification(AComponent, Operation);
end;

procedure TADOUserControl.ActionLog(Sender: TObject);
begin
  inherited;
  TViewLog(FormLogControl).DSLog := TADOQuery.Create(nil);
  TADOQuery(tViewLog(FormLogControl).DSLog).Connection := FConnection;
  TViewLog(FormLogControl).DSCmd :=TADOQuery.Create(nil);
  TADOQuery(tViewLog(FormLogControl).DSCmd).Connection := FConnection;
  FormLogControl.ShowModal;
  FreeandNil(FormLogControl);
end;


procedure TADOUserControl.UCExecSQL(FSQL: String);
begin
  FConnection.Execute(FSQL);
end;


function TADOUserControl.UCGetSQLDataset(FSQL: String): TDataset;
begin
  Result := TADOQuery.Create(nil);
  with Result as TADOQuery do
  begin
    Connection := FConnection;
    SQL.text := FSQL;
    Open;
  end;
end;

function TADOUserControl.UCFindTable(const TableName: String): Boolean;
var
  TempList : TStringList;
begin
  try
    TempList := TStringList.Create;
    FConnection.GetTableNames(TempList,True);
    TempList.Text := UpperCase(TempList.Text);
    Result := TempList.IndexOf(UpperCase(TableName)) > -1;
  finally
    FreeAndNil(TempList);
  end;
end;

function TADOUserControl.UCFindDataConnection: Boolean;
begin
    Result := Assigned(FConnection);
end;

end.
