unit CadUser_U;

interface

uses
{$IFDEF Ver130}
{$ELSE}
  Variants,
{$ENDIF}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, DBGrids, DB,
  ExtCtrls, Menus, UCDefine;

type
  TCadUser = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    lbDescricao: TLabel;
    Image1: TImage;
    PopupMenu1: TPopupMenu;
    Alterar1: TMenuItem;
    Excluir1: TMenuItem;
    N1: TMenuItem;
    Permisses1: TMenuItem;
    Panel3: TPanel;
    btAdic: TSpeedButton;
    BtAlt: TSpeedButton;
    BtExclui: TSpeedButton;
    BtAcess: TSpeedButton;
    BtExit: TSpeedButton;
    BtPass: TSpeedButton;
    DataSource2: TDataSource;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn5Click(Sender: TObject);
    procedure BtExitClick(Sender: TObject);
    procedure btAdicClick(Sender: TObject);
    procedure BtAltClick(Sender: TObject);
    procedure BtExcluiClick(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure BtPassClick(Sender: TObject);
    procedure SetWindow(Adicionar: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure DSCadUserAfterScroll(DataSet: TDataSet);
    procedure FormShow(Sender: TObject);
  private
    LockAdmin : Boolean;
    { Private declarations }
  public
    DSCadUser, DSCmd, DSPerfilUser, DSNewId : TDataset;
    FParam : TParams;
  end;

var
  CadUser: TCadUser;

implementation

uses IncUser_U;

{$R *.dfm}

procedure TCadUser.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action := caFree;
end;

procedure TCadUser.BitBtn5Click(Sender: TObject);
begin
  Close;
end;

procedure TCadUser.BtExitClick(Sender: TObject);
begin
  Close;
end;

procedure TCadUser.btAdicClick(Sender: TObject);
begin
  IncUser := TIncUser.Create(self);
  SetWindow(True);
  IncUser.ShowModal;
  FreeAndNil(IncUser);
end;
procedure TCadUser.SetWindow(Adicionar : Boolean);
begin
  with TUCDefine(owner).Settings.AddChangeUser do begin
    IncUser.Caption := WindowCaption;
    if Adicionar then IncUser.LbDescricao.Caption := LabelAdd else IncUser.LbDescricao.Caption := LabelChange;
    IncUser.lbNome.Caption := LabelName;
    IncUser.lbLogin.Caption := LabelLogin;
    IncUser.lbEmail.Caption := LabelEmail;
    IncUser.ckPrivilegiado.Caption := CheckPrivileged;
    IncUser.btGravar.Caption := BtSave;
    IncUser.btCancela.Caption := BtCancel;
  end;
end;
procedure TCadUser.BtAltClick(Sender: TObject);
begin
  if DSCadUser.RecordCount = 0 then Exit;
  IncUser := TIncUser.Create(self);
  SetWindow(False);
  With IncUser do begin
    FAltera := True;
    EditNome.Text := DSCadUser.FieldByName('Nome').asString;
    EditLogin.Text := DSCadUser.FieldByName('Login').asString;
    EditEmail.Text := DSCadUser.FieldByName('Email').asString;
    ComboPerfil.KeyValue := DSCadUser.FieldByName('Perfil').asInteger;
    ckPrivilegiado.Checked := StrToBool(DSCadUser.FieldByName('Privilegiado').asString);
    ShowModal;
  end;
  FreeAndNil(IncUser);
end;

procedure TCadUser.BtExcluiClick(Sender: TObject);
var
  TempID : Integer;
  CanDelete : Boolean;
  ErrorMsg : String;
begin
  if DSCadUser.RecordCount = 0 then Exit;
  TempID := DSCadUser.fieldByName('IDUser').asInteger;
  if MessageDlg(Format(TUCDefine(Owner).Settings.UsersForm.PromptDelete, [DSCadUser.fieldByName('Nome').asString]), mtConfirmation, [mbYes,mbNo], 0) = mrYes then begin
    CanDelete := True;
    if Assigned(TUCDefine(Owner).onDeleteUser) then TUCDefine(Owner).onDeleteUser(TObject(Owner),TempID, CanDelete, ErrorMsg);
    if Not CanDelete then begin
      MessageDlg(ErrorMSG, mtWarning, [mbOK], 0);
      Exit;
    end;
    DSCMD.Close;
    try // idapi32.dll exception
      IProviderSupport(DSCMD).PSExecuteStatement('Delete from '+ TUCDefine(Owner).TableRights + ' where IDUser = '+ IntToStr(TempID), FParam);
    except end;
    IProviderSupport(DSCMD).PSExecuteStatement('Delete from '+ TUCDefine(Owner).TableUsers + ' where IDUser = '+ IntToStr(TempID), FParam);
    DSCadUser.Close;
    DSCadUser.Open;
  end;
end;

procedure TCadUser.DBGrid1DblClick(Sender: TObject);
begin
  BtAlt.Click;
end;

procedure TCadUser.BtPassClick(Sender: TObject);
var
  FNovasenha : String;
  nome, login, email : String;

begin
  if DSCadUser.RecordCount = 0 then Exit;
  if Inputquery(Format(TUCDefine(Owner).Settings.ResetPassword.WindowCaption,[DSCadUser.FieldByName('Login').asString]), TUCDefine(Owner).Settings.ResetPassword.LabelPassword ,FNovaSenha) then
  begin
{$IFDEF VER130}
{$ELSE}
    if (Assigned(TUCDefine(Owner).MailUserControl)) and (TUCDefine(Owner).MailUserControl.SenhaForcada.Ativo ) then
      try
        with DSCadUser do
        begin
          nome := fieldbyname('nome').asString;
          login := fieldbyname('login').asString;
          email := fieldbyname('email').asString;
        end;
        TUCDefine(Owner).MailUserControl.EnviaEmailSenhaForcada(
                                         nome,
                                         login,
                                         FNovasenha,
                                         email,
                                         '');
      except
        on E : Exception do TUCDefine(Owner).Log(e.Message,2);
      end;
{$ENDIF}
    IProviderSupport(DSCMD).PSExecuteStatement('UPDATE ' + TUCDefine(Owner).TableUsers + ' Set Senha = '+ QuotedStr(Encrypt(FNovasenha, TUCDefine(Owner).EncryptKey)) + ' Where IDUser = ' + DSCadUser.FieldByName('IDUser').asString ,FParam);
  end;
end;

procedure TCadUser.FormCreate(Sender: TObject);
begin
  LockAdmin := TUCDefine(Owner).UsersForm.ProtectAdmin;
  FParam := TParams.Create;
end;

procedure TCadUser.DSCadUserAfterScroll(DataSet: TDataSet);
begin
  if (LockAdmin) and (Dataset.fieldbyname('Login').asString = TUCDefine(Owner).Login.InitialLogin.User) then begin
    BtExclui.Enabled := False;
    BtPass.Enabled := False;
    if TUCDefine(Owner).CurrentUser.Username <> TUCDefine(Owner).Login.InitialLogin.User then BtAcess.Enabled := False;
  end else begin
    BtExclui.Enabled := True;
    BtPass.Enabled := True;
    BtAcess.Enabled := True;
  end;
end;

procedure TCadUser.FormShow(Sender: TObject);
begin
  DataSource1.Dataset :=  DSCadUser;
  DataSource2.Dataset :=  DSPerfilUser;
  DSCadUser.AfterScroll := DSCadUserAfterScroll;
  DSCadUserAfterScroll(DSCadUser);  
end;

end.
